uses crt;

const NB:boolean=false;

var CS:longint;
    BUF:array[1..64100] of char;
    CODE:word;

procedure Print(S:string;C,BC:byte;NL:boolean);
begin
  textattr:=C+BC*16;
  write(S);
  textattr:=7;
  if NL then writeln
end;

procedure Help;
begin
  writeln;      
  Print('Cutting:',15,0,true);
  writeln('BAGA  Source  Output1  Output2  Cut_size_for_Output1  [N]o_backup');
  writeln('Ex) BG TEST T1 T2 1000');
  writeln;
  Print('Put together:',15,0,true);
  writeln('BAGA  \  Source1  Source2  Output(Cutting source)  [N]o_backup');
  writeln('Ex) BG \ T1 T2 TEST N');
  halt
end;

procedure IOCheck;
begin
  if ioresult<>0 then
  begin
    writeln('Input/Output Error!');
    halt
  end
end;

procedure FileErase(EF:string);
var F:file;
begin
  assign(F,EF);
  erase(F)
end;

procedure FileCopy(F,T:string;SF:longint;var FST:longint;WC:longint;NF:boolean);
var F_F,T_F:file;
    NUMREAD,NUMWRITTEN:word;
begin
  assign(F_F,F);
  assign(T_F,T);
  {$I-}
  reset(F_F,1);
  IOCheck;
  if NF then reset(T_F,1) else rewrite(T_F,1);
  {$I+}

  seek(F_F,SF);
  seek(T_F,filesize(T_F));

  repeat
    blockread(F_F,BUF,SIZEOF(BUF),NUMREAD);
    if (WC>0) and (filesize(T_F)>WC) then NUMREAD:=0;
    blockwrite(T_F,BUF,NUMREAD,NUMWRITTEN)
  until (NUMREAD=0) or (NUMWRITTEN<>NUMREAD) or (NUMREAD>=filesize(F_F));

  if WC>0 then
  begin
    seek(T_F,WC);
    truncate(T_F)
  end;

  FST:=filesize(T_F);
  close(F_F);
  close(T_F)
end;

procedure PutTogether(F1,F2,T:string);
var FS:longint;
begin
  Print('PUT TOGETHER!',11,0,true);
  FileCopy(F1,T,0,FS,0,false);
  FileCopy(F2,T,0,FS,0,true);
  if NB then
  begin
    FileErase(F1);
    FileErase(F2)
  end;
  writeln('INFO: ',F1,' + ',F2,' = ',T,' (',FS,')')
end;

procedure Cutting(F1,T1,T2:string;CS:longint);
var FS:longint;
begin
  Print('CUTTING!',10,0,true);
  FileCopy(F1,T1,0,FS,CS,false);
  FileCopy(F1,T2,CS,FS,0,false);
  if NB then FileErase(F1);
  writeln('INFO: ',F1,' = ',T1, ' (',CS,') + ',T2,' (',FS,')')
end;

begin
  writeln;
  Print('BA-nul & GA-wi 1.5.0  (c) 1992, 1993 KIM, JIN HONG (aromanix)      COREA',15,3,true);
  if paramcount<4 then Help;
  if (paramstr(5)='n') or (paramstr(5)='N') then NB:=true;
  if paramstr(1)='\' then PutTogether(paramstr(2),paramstr(3),paramstr(4))
  else begin
    val(paramstr(4),CS,CODE);
    Cutting(paramstr(1),paramstr(2),paramstr(3),CS)
  end
end.
