uses hexwrite,crt,textfont;

const WF=#0;
      Kim:FontType=($F9,$09,$09,$09,$19,$31,$61,$C1,$00,$FF,$81,$81,$FF,$00,$00,$00);
      Jin:FontType=($F9,$21,$21,$21,$21,$21,$51,$89,$00,$80,$80,$80,$FF,$00,$00,$00);
      Hong:FontType=($10,$FE,$00,$FE,$82,$FE,$10,$10,$FE,$00,$FE,$82,$FE,$00,$00,$00);

type FontCell=array[1..16] of string[8];

var X,Y:byte;
    Font:FontCell;
    SF,CF,SK,SJ,SH:FontType;

function Inkey:char;
var C:char;
begin
  if keypressed then begin
    C:=readkey;
    if C=#0 then C:=readkey;
    Inkey:=C
  end else Inkey:=#0
end;

procedure DrawBin;
var T,I,SX,SY:byte;
    F:FontCell;
begin
  SX:=wherex;
  SY:=wherey;
  F:=Font;
  for T:=1 to 16 do
    for I:=1 to 8 do
      if F[T][I]='0' then F[T][I]:='.' else F[T][I]:=#219;

  for T:=1 to 16 do begin
    gotoxy(10,4+T);
    write(F[T])
  end;
  gotoxy(SX,SY)
end;

procedure ChangeFont;
var T:byte;
begin
  for T:=0 to 15 do begin
    CF[T]:=ANumBin(Font[succ(T)]);
    gotoxy(21,5+T);
    write(HexByte(CF[T]),CF[T]:10)
  end;
  setfont(ord(WF),CF)
end;

procedure InitFont;
var T:byte;
begin
  gotoxy(40,12);
  write('[ '+WF+' ]');
  gotoxy(20,4);
  writeln('HEX   INTEGER');

  for T:=1 to 16 do begin
    Font[T]:='00000000';
    CF[pred(T)]:=0
  end;

  getfont(ord(WF),SF);
  getfont(253,SK);
  getfont(254,SJ);
  getfont(255,SH);

  setfont(ord(WF),CF);
  setfont(253,KIM);
  setfont(254,JIN);
  setfont(255,HONG)
end;

procedure PutAndUnPoint;
begin
  if Font[Y][X]='0' then Font[Y][X]:='1' else Font[Y][X]:='0'
end;

procedure PutPoint;
begin Font[Y][X]:='1' end;

procedure ClearFont;
var T:byte;
begin
  for T:=1 to 16 do Font[T]:='00000000'
end;

procedure InverseX;
var T,I:byte;
    C:string[8];
begin
  for T:=1 to 16 do begin
    for I:=1 to 4 do begin
      C:=Font[T];
      Font[T][I]:=C[9-I];
      Font[T][9-I]:=C[I]
    end;
    CF[pred(T)]:=ANumBin(Font[T])
  end
end;

procedure InverseY;
var T:byte;
    C:string[8];
begin
  for T:=1 to 8 do begin
    C:=Font[T];
    Font[T]:=Font[17-T];
    Font[17-T]:=C;
    CF[pred(T)]:=ANumBin(Font[T])
  end
end;

procedure Ending;
begin
  clrscr;
  setfont(ord(WF),SF);
  setfont(253,SK);
  setfont(254,SJ);
  setfont(255,SH);
  halt
end;

procedure Load;
var T,I:byte;
    F:text;
    S:string;
begin
  gotoxy(50,5);
  write('Load Name: ');
  readln(S);
  gotoxy(50,5);
  write('                            ');
  if S='' then exit;

  assign(F,S);
  {$I-}
  reset(F);
  {$I+}
  if ioresult<>0 then begin
    sound(1000);
    delay(100);
    sound(5000);
    delay(50);
    nosound;
    exit
  end;
  readln(F,S);
  close(F);

  for T:=1 to 16 do begin
    CF[pred(T)]:=ord(S[T]);
    Font[T]:=BinByte(CF[pred(T)])
  end
end;

procedure Save;
var T:byte;
    F:text;
    S:string;
begin
  gotoxy(50,5);
  write('Save Name: ');
  readln(S);
  gotoxy(50,5);
  write('                            ');
  if S='' then exit;

  assign(F,S);
  rewrite(F);
  for T:=0 to 15 do write(F,chr(CF[T]));
  close(F);
  sound(3000);
  delay(100);
  nosound
end;

procedure Conv;
var T:byte;
    F:text;
    S:string;
begin
  gotoxy(50,5);
  write('Conv.Pas. Save Name: ');
  readln(S);
  gotoxy(50,5);
  write('                                  ');
  if S='' then exit;

  assign(F,S);
  rewrite(F);
  write(F,':FontType=(');
  for T:=0 to 14 do write(F,'$',HexByte(CF[T]),',');
  write(F,'$',HexByte(CF[15]),');');
  close(F)
end;

procedure Shift;
var KEY:byte absolute 0:$417;
begin
  if (KEY and 2<>0) or (KEY and 1<>0) then Font[Y][X]:='1'
end;

procedure Del;
var T:byte;
begin
  for T:=Y to 15 do begin
    CF[pred(T)]:=CF[T];
    Font[T]:=Font[succ(T)]
  end;
  Font[16]:='00000000';
  CF[15]:=0
end;

procedure Ins;
var T:byte;
begin
  for T:=16 downto succ(Y) do begin
    CF[pred(T)]:=CF[T-2];
    Font[T]:=Font[pred(T)]
  end;
  Font[Y]:='00000000';
  CF[pred(Y)]:=0
end;

var K:char;
begin
  X:=1;
  Y:=1;

  clrscr;
  textattr:=31;
  writeln('Font Editor 1.2, Copyright 1994 by '#253#32#254#32#255'. PENTAGRAM');
  textattr:=7;
  writeln('ESC Quit   ARROW Move-Cursor   SHIFT+ARROW Draw-Line');
  gotoxy(1,22);
  writeln('F2 Save   F3 Load   F4 Inverse-X   F5 Inverse-Y   F6 Clear   F7 Conversion-Pas');
  writeln('INS Insert-Line   DEL Delete-Line   SPACE Put&UnPut   ENTER Put');
  InitFont;
  DrawBin;
  gotoxy(10,5);

  repeat
    repeat K:=Inkey until K<>#0;
    case K of
      #13:PutPoint;
      #83:Del;
      #82:Ins;
      #65:Conv;
      #61:Load;
      #63:InverseY;
      #62:InverseX;
      #60:Save;
      #64:ClearFont;
      #72:if Y>1 then dec(Y) else Y:=16;
      #80:if Y<16 then inc(Y) else Y:=1;
      #75:if X>1 then dec(X) else X:=8;
      #77:if X<8 then inc(X) else X:=1;
      #32:PutAndUnPoint;
      #27:Ending
    end;
    Shift;
    ChangeFont;
    DrawBin;
    gotoxy(X+9,Y+4);
  until false
end.