(*   Snow Parker 1.6
     PRODUCTION: WindGram
     KIM, JIN HONG [Mesmeric]
     1994.12.18
*)

{$R-}
{$Q-}

uses
  dos,crt,textfont,adlib,option;

type
  VGAScreen = array[0..199,0..319] of byte;
var
  DOT:VGAScreen absolute $A000:0000;
  F,SF:array[0..255] of FontType;

const
  Italic    =128;
  Boldface  =64;
  Lightface =32;
  OutLine   =16;
  Inverse   =8;
  Normal    =4;
  CharS:byte=9;
  CharX:byte=1;
  CharY:byte=1;
  SX=58;

type Snow=object
       x,y:word;
       constructor Init;
       procedure Coord(N:byte);
       procedure UnDraw; virtual;
       procedure Draw; virtual;
     end;

     SnowBigger=object(Snow)
       procedure UnDraw; virtual;
       procedure Draw; virtual;
     end;

     SnowBiggest=object(Snow)
       procedure UnDraw; virtual;
       procedure Draw; virtual;
     end;

const
  Numberofsnow=150;

var
    S:array[1..Numberofsnow] of ^Snow;
    S2:array[1..Numberofsnow-50] of ^SnowBigger;
    S3:array[1..Numberofsnow-100] of ^SnowBiggest;
    TimeTick:longint absolute $0040:$006C;

procedure SnowBiggest.UnDraw;
begin
  dot[y,x]:=0;
  dot[y,x+1]:=0;
  dot[y+1,x]:=0;
  dot[y+1,x+1]:=0;
  dot[y+1,x-1]:=0;
  dot[y+2,x]:=0
end;

procedure SnowBiggest.Draw;
begin
  dot[y,x]:=15;
  dot[y,x+1]:=15;
  dot[y+1,x]:=15;
  dot[y+1,x+1]:=15;
  dot[y+1,x-1]:=15;
  dot[y+2,x]:=15
end;

procedure SnowBigger.UnDraw;
begin
  dot[y,x]:=0;
  dot[y,x+1]:=0;
  dot[y+1,x]:=0
end;

procedure SnowBigger.Draw;
begin
  dot[y,x]:=7;
  dot[y,x+1]:=7;
  dot[y+1,x]:=7
end;

constructor Snow.Init;
begin
  x:=random(319);
  y:=random(106)+61;
end;

procedure Snow.Coord;
begin
  if y<167 then inc(y,N) else y:=61;
  if y>167 then y:=61;
  if random(2)=0 then if x<319 then inc(x,N) else x:=0;
  if random(10)=0 then if x>N then dec(x,N) else x:=319
end;

procedure Snow.UnDraw;
begin dot[y,x]:=0 end;

procedure Snow.Draw;
begin dot[y,x]:=8 end;

PROCEDURE NewWriterInit;
var T:byte;
begin
  for T:=0 to 255 do GetFont(T,F[T]);
  SF:=F { save original fonts }
end;

PROCEDURE NewFont(FT:byte);
var I,T:byte;
begin
  if FT and Normal<>0 then F:=SF; { normal }

  if FT and Italic<>0 then
    for I:=0 to 255 do begin
      for T:= 0 to 2 do F[I,T]:=(F[I,T] shr 3) and $1f;
      for T:= 3 to 5 do F[I,T]:=(F[I,T] shr 2) and $3f;
      for T:= 6 to 8 do F[I,T]:=(F[I,T] shr 1) and $7f
    end;

  if FT and Boldface<>0 then
    for I:=0 to 255 do
      for T:=0 to 14 do F[I,T]:=F[I,T] or ((F[I,T] shr 1)) and $7f;

  if FT and Lightface<>0 then
    for I:=0 to 255 do
      for T:=0 to 14 do F[I,T]:=F[I,T] and ((F[I,T] shr 1)) and $7f;

  if FT and OutLine<>0 then
    for I:=0 to 255 do
      for T:=0 to 14 do F[I,T]:=((F[I,T] shr 1) and $7f) xor F[I,T+1];

  if FT and Inverse<>0 then
    for I:=0 to 255 do
      for T:=0 to 15 do F[I,T]:=not F[I,T]
end;

PROCEDURE GraphicMode; assembler;
asm
  mov AH,0
  mov al,13H
  Int 10H
end;

PROCEDURE TextMode; assembler;
asm
  mov AH,0
  mov al,3
  Int 10H
end;

PROCEDURE WriteXY(S:string;X,Y:integer;C,D:byte);
var T,XC,YC,N:byte;
begin
  for T:=1 to length(S) do
    for YC:=0 to 15 do begin
      N:=128;
      for XC:=0 to 7 do begin
        delay(D);
        if F[ord(S[T]),YC] and N<>0 then
          if C=255 then DOT[YC*CharY+Y,XC*CharX+X+(T*CharS)]:=random(255)
          else if C=254 then DOT[YC*CharY+Y,XC*CharX+X+(T*CharS)]:=16+YC
          else if C=253 then DOT[YC*CharY+Y,XC*CharX+X+(T*CharS)]:=random(16)+16
          else if C=252 then DOT[YC*CharY+Y,XC*CharX+X+(T*CharS)]:=(TimeTick mod 100)-YC
          else if C=251 then DOT[YC*CharY+Y,XC*CharX+X+(T*CharS)]:=(TimeTick mod 7)+YC+15
          else DOT[YC*CharY+Y,XC*CharX+X+(T*CharS)]:=C;
        N:=N div 2
      end
    end
end;

var Drive,Park_Ok:word;
    Regs:registers;
    Count:word;
    T:byte;
    CSD:boolean;

procedure Parking(Drive,Park_ok :byte);
var re:byte;
begin
   { recalibrate drive, 80h:first drive, 81h:second.. }
   asm
        mov     ah,11h
        mov     dl,drive
        int     13h
        pushf
        pop     ax
        and     ax,00000001b
        mov     re,al
   end;

   if  re=1 then begin
     writeln('Hard disk has some trouble!');
     exit;
   end;

   { get drive parameters }
   asm
        mov     ah,8h
        mov     dl,drive
        int     13h

{ return:   CH = low eight bits of maximum cylinder number
	    CL = maximum sector number (bits 5-0)
		 high two bits of maximum cylinder number (bits 7-6)
	    DH = maximum head number
	    DL = number of drives}

{ input: CH = low eight bits of cylinder number
         CL = sector number (bits 5-0)
	    high two bits of cylinder number (bits 7-6)
	 DH = head number
	 DL = drive number (80h = first, 81h = second hard disk)}

        mov     ah,0ch
        mov     dl,drive
        int     13h
   end;
end;

procedure DrawLines;
var X:word;
begin
  for X:=0 to 319 do begin
    DOT[60,X]:=20;
    DOT[170,319-X]:=20;
    delay(3)
  end
end;

function FindFile(S:string):boolean;
var DI:searchrec;
begin
 findfirst(S,anyfile,DI);
 if doserror=0 then FindFile:=true else FindFile:=false
end;

procedure ColorBackGround;
var X,Y:word;
begin
  for Y:=171 to 199 do
    for X:=0 to 319 do DOT[Y,X]:=17
end;

var
  SS:string;
  M:boolean;
  O:string;

begin
   Park_Ok := 0;
   Drive := $80;   { bit 7 set for hard disk }

   regs.ax := $800; { mov ah, 08h}
   Regs.cx := 0;
   regs.dl := Drive; { dl == number of drives }
   Intr($13,regs);
   Count := Regs.dl;

   If (regs.Flags = 1) or ( Count = 0 ) then begin
     Writeln('Parking Error!');
     Exit
   end else Begin
     If Count > 2 then Count := 2;

     Repeat
        parking(drive,park_ok);
        Inc(Drive);
        Dec(Count)
     Until  Count=0;

     If Park_Ok = 128 then Begin
       Writeln('Parking Error!');
       Exit
     End;
   end;

  CSD:=InitSound;
  if not CSD then writeln('Sound driver not found!');
  if not FindFile(copy(paramstr(0),1,length(paramstr(0))-3)+'BNK') then begin
    writeln('Music data ''PARK.BNK'' not found!');
    CSD:=false
  end;
  if not FindFile(copy(paramstr(0),1,length(paramstr(0))-3)+'ROL') then begin
     writeln('Music data ''PARK.ROL'' not found!');
     CSD:=false
  end;

  if not CSD then begin
    writeln('Music will not play!');
    delay(600)
  end;

  if CSD then begin
    LoadBank(copy(paramstr(0),1,length(paramstr(0))-3)+'BNK');
    LoadSong(copy(paramstr(0),1,length(paramstr(0))-3)+'ROL');
    initinsound
  end;

  if paramcount>0 then begin
    SS:=getparameters;
    SS:=copy(SS,1,15)
  end else SS:=' THE  WindGram';

  NewWriterInit;
  GraphicMode;
  randomize;

  ColorBackGround;
  NewFont(LightFace);
  CharS:=18;
  CharY:=2;
  CharX:=2;
  WriteXY(SS,6,170,253,0);
  CharS:=9;

  CharX:=1;
  NewFont(Normal+BoldFace);
  CharY:=2;
  CharS:=10;
  WriteXY(#4'             . '#4,1+SX,10,254,0);
  WriteXY('Snow Parker 1.6',11+SX,10,150,0);
  WriteXY('Snow Parker 1.6',11+SX,11,150,0);
  WriteXY('Snow Parker',10+SX,10,254,0);
  WriteXY('Snow Parker',10+SX,11,254,0);
  WriteXY('1.6',131+SX,10,254,0);
  CharY:=1;

  NewFont(Normal+LightFace);
  WriteXY(#7'Fixed Disk Parked'#7,50,42,7,0);
  DrawLines;

  NewFont(Normal+BoldFace);
  CharS:=18;
  CharY:=2;
  CharX:=2;

  for T:=1 to Numberofsnow do new(S[T],Init);
  for T:=1 to Numberofsnow-50 do new(S2[T],Init);
  for T:=1 to Numberofsnow-100 do new(S3[T],Init);

  repeat
    for T:=1 to Numberofsnow do begin
      S[T]^.UnDraw;
      S[T]^.Coord(1);
      S[T]^.Draw
    end;
    for T:=1 to Numberofsnow-50 do begin
      S2[T]^.UnDraw;
      S2[T]^.Coord(2);
      S2[T]^.Draw
    end;
    for T:=1 to Numberofsnow-100 do begin
      S3[T]^.UnDraw;
      S3[T]^.Coord(3);
      S3[T]^.Draw
    end;

    delay(20);
    WriteXY(SS,6,170,253,0);
    CharS:=10;
    CharX:=1;
    WriteXY('1 6',131+SX,10,252,0);
    WriteXY(#4'               '#4,1+SX,10,251,0);
    CharS:=18;
    CharX:=2;
    if CSD then playsong
  until keypressed;

  mem[0:$41A]:=mem[0:$41C];
  if CSD then playoff;
  Textmode
end.
