(*   Snow Parker 1.1
     CODE: KIM, JIN HONG [Izzer Fil]
     1994.9.24
*)

{$X+}
{$R-}

uses
  dos,crt,textfont,adlib;

type
  VGAScreen = array[0..199,0..319] of byte;
var
  DOT:VGAScreen absolute $A000:0000;
  F,SF:array[0..255] of FontType;

const
  Italic    =128;
  Boldface  =64;
  Lightface =32;
  OutLine   =16;
  Inverse   =8;
  Normal    =4;
  CharS:byte=9;
  CharX:byte=1;
  CharY:byte=1;
  SX=58;

type Snow=object
       x,y:word;
       constructor Init;
       procedure Coord(N:byte);
       procedure UnDraw; virtual;
       procedure Draw; virtual;
     end;

     SnowBigger=object(Snow)
       procedure UnDraw; virtual;
       procedure Draw; virtual;
     end;

     SnowBiggest=object(Snow)
       procedure UnDraw; virtual;
       procedure Draw; virtual;
     end;

const
  Numberofsnow=150;  {max:200}

var
    S:array[1..Numberofsnow] of ^Snow;
    S2:array[1..Numberofsnow-50] of ^SnowBigger;
    S3:array[1..Numberofsnow-100] of ^SnowBiggest;

procedure SnowBiggest.UnDraw;
begin
  dot[y,x]:=0;
  dot[y,x+1]:=0;
  dot[y+1,x]:=0;
  dot[y+1,x+1]:=0;
  dot[y+1,x-1]:=0;
  dot[y+2,x]:=0
end;

procedure SnowBiggest.Draw;
begin
    dot[y,x]:=15;
    dot[y,x+1]:=15;
    dot[y+1,x]:=15;
    dot[y+1,x+1]:=15;
    dot[y+1,x-1]:=15;
    dot[y+2,x]:=15
end;

procedure SnowBigger.UnDraw;
begin
  dot[y,x]:=0;
  dot[y,x+1]:=0;
  dot[y+1,x]:=0
end;

procedure SnowBigger.Draw;
begin
  dot[y,x]:=15;
  dot[y,x+1]:=15;
  dot[y+1,x]:=15
end;

constructor Snow.Init;
begin
  x:=random(319);
  y:=random(90)+70;
end;

procedure Snow.Coord;
begin
  if y<160 then inc(y,N) else y:=70;
  if y>160 then y:=70;
  if random(2)=0 then if x<319 then inc(x,N) else x:=0;
  if random(10)=0 then if x>N then dec(x,N) else x:=319
end;

procedure Snow.UnDraw;
begin dot[y,x]:=0 end;

procedure Snow.Draw;
begin dot[y,x]:=15 end;

PROCEDURE NewWriterInit;
var T:byte;
begin
  for T:=0 to 255 do GetFont(T,F[T]);
  SF:=F { save original fonts }
end;

PROCEDURE NewFont(FT:byte);
var I,T:byte;
begin
  if FT and Normal<>0 then F:=SF; { normal }

  if FT and Italic<>0 then
    for I:=0 to 255 do begin
      for T:= 0 to 2 do F[I,T]:=(F[I,T] shr 3) and $1f;
      for T:= 3 to 5 do F[I,T]:=(F[I,T] shr 2) and $3f;
      for T:= 6 to 8 do F[I,T]:=(F[I,T] shr 1) and $7f
    end;

  if FT and Boldface<>0 then
    for I:=0 to 255 do
      for T:=0 to 14 do F[I,T]:=F[I,T] or ((F[I,T] shr 1)) and $7f;

  if FT and Lightface<>0 then
    for I:=0 to 255 do
      for T:=0 to 14 do F[I,T]:=F[I,T] and ((F[I,T] shr 1)) and $7f;

  if FT and OutLine<>0 then
    for I:=0 to 255 do
      for T:=0 to 14 do F[I,T]:=((F[I,T] shr 1) and $7f) xor F[I,T+1];

  if FT and Inverse<>0 then
    for I:=0 to 255 do
      for T:=0 to 15 do F[I,T]:=not F[I,T]
end;

PROCEDURE GraphicMode; assembler;
asm
  mov AH,0
  mov al,13H
  Int 10H
end;

PROCEDURE TextMode; assembler;
asm
  mov AH,0
  mov al,3
  Int 10H
end;

PROCEDURE WriteXY(S:string;X,Y:integer;C,D:byte);
var T,XC,YC,N:byte;
begin
  for T:=1 to length(S) do
    for YC:=0 to 15 do begin
      N:=128;
      for XC:=0 to 7 do begin
        delay(D);
        if F[ord(S[T]),YC] and N<>0 then
          if C=255 then DOT[YC*CharY+Y,XC*CharX+X+(T*CharS)]:=random(255)
          else if C=254 then DOT[YC*CharY+Y,XC*CharX+X+(T*CharS)]:=16+YC
          else if C=253 then DOT[YC*CharY+Y,XC*CharX+X+(T*CharS)]:=random(16)+16
          else DOT[YC*CharY+Y,XC*CharX+X+(T*CharS)]:=C;
        N:=N div 2
      end
    end
end;

PROCEDURE WriteXY2(S:string;X,Y:integer;C,D:byte;NLR:real);
var T,XC,YC,N:byte; NL:real;
begin
  NL:=0;
  for T:=1 to length(S) do begin
    N:=128;
    for XC:=0 to 7 do begin
      for YC:=0 to 15 do begin
        delay(D);
        NL:=NL+NLR;
        if F[ord(S[T]),YC] and N<>0 then
          if C=255 then DOT[trunc(NL)+YC*CharY+Y,XC*CharX+X+(T*CharS)]:=random(255)
          else if C=254 then DOT[trunc(NL)+YC*CharY+Y,XC*CharX+X+(T*CharS)]:=16+YC
          else DOT[trunc(NL)+YC*CharY+Y,XC*CharX+X+(T*CharS)]:=C;
      end;
      N:=N div 2
    end
  end
end;

var Drive,Park_Ok:word;
    Regs:registers;
    Count:word;
    T:byte;
    CSD:boolean;

procedure Parking(Drive,Park_ok :Word);
Begin
   Regs.ax := 4352;
   Regs.cx := 0;
   Regs.dx := Drive;
   Intr($13,Regs);

   If Regs.flags <> 0 then Exit;
   Park_ok := 128;

   regs.ax := 3072;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);

   regs.ax := 2048;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);

   regs.ax := 3072;
   Regs.cx := 0;
   Regs.Dx := Drive;
   Intr($13,Regs);
End;

procedure DrawLines;
var X:word;
begin
  for X:=0 to 319 do begin
    DOT[60,X]:=15;
    DOT[170,319-X]:=15;
    delay(5)
  end
end;

Begin
   Park_Ok := 0;
   Drive := $80;

   regs.ax := $800;
   Regs.cx := 0;
   regs.dx := Drive;
   Intr($13,regs);

   Count := Regs.dl;

   If (regs.Flags = 1) or ( Count = 0 ) then begin
     Writeln('Parking Error!');
     Exit
   end else Begin
     If Count > 2 then Count := 2;

     Repeat
        parking(drive,park_ok);
        Inc(Drive);
        Dec(Count)
     Until  Count=0;

     If Park_Ok = 128 then Begin
       Writeln('Parking Error!');
       Exit
     End;
   end;

  CSD:=InitSound;

  if CSD then begin
    LoadBank(copy(paramstr(0),1,length(paramstr(0))-3)+'INS');
    loadsong(copy(paramstr(0),1,length(paramstr(0))-3)+'DAT');
    initinsound
  end;

  NewWriterInit;
  GraphicMode;
  randomize;

  NewFont(BoldFace);
  CharS:=18;
  CharY:=2;
  CharX:=2;
  WriteXY('Izzer Fil',56,170,253,0);
  CharS:=9;

  CharX:=1;
  NewFont(Normal+BoldFace);
  CharY:=2;
  CharS:=10;
  WriteXY(#16'             . '#17,1+SX,10,254,0);
  WriteXY('Snow Parker 1.1',11+SX,10,150,0);
  WriteXY2('Snow Parker',9+SX,10,254,1,0);
  WriteXY('1 1',131+SX,10,255,2);
  CharY:=1;

  NewFont(Normal+LightFace);
  WriteXY2(#7'Fixed Disc Parked'#7,50,42,7,0,0);
  DrawLines;

  NewFont(Normal+BoldFace);
  CharS:=18;
  CharY:=2;
  CharX:=2;

  for T:=1 to Numberofsnow do new(S[T],Init);
  for T:=1 to Numberofsnow-50 do new(S2[T],Init);
  for T:=1 to Numberofsnow-100 do new(S3[T],Init);

  repeat
    for T:=1 to Numberofsnow do begin
      S[T]^.UnDraw;
      S[T]^.Coord(1);
      if dot[s[t]^.y,s[t]^.x]=0 then begin
        S[T]^.Draw
      end
    end;
    for T:=1 to Numberofsnow-50 do begin
      S2[T]^.UnDraw;
      S2[T]^.Coord(2);
      S2[T]^.Draw
    end;
    for T:=1 to Numberofsnow-100 do begin
      S3[T]^.UnDraw;
      S3[T]^.Coord(3);
      S3[T]^.Draw
    end;

    delay(20);
    WriteXY('Izzer Fil',56,170,253,0);
  	if CSD then playsong
  until keypressed;

  readkey;
  if CSD then playoff;
  Textmode
end.
